﻿// Úvod do LINQ

namespace Čtvrtý
{
    enum Typ { Soukromý, Pracovní}
    class Kontakt
    {
        public string Jméno { get; set; }
        public string Příjmení { get; set; }
        public string Telefon { get; set; }
        public Typ Typ { get; set; }
        public Kontakt(string jméno, string příjmení, string telefon, Typ typ)
        {
            (Jméno, Příjmení, Telefon, Typ) = (jméno, příjmení, telefon, typ);
        }
        public override string ToString()
        {
            return Jméno + " " + Příjmení + ": " + Telefon + " (" + Typ + ")";
        }
    }

    internal class Program
    {
        static List<Kontakt> kontakty = new();
        static void Příprava()
        {
            kontakty.Clear();
            kontakty.Add(new Kontakt("Eva", "Veselská", "564125877", Typ.Pracovní));
            kontakty.Add(new Kontakt("Jan", "Novák", "123456789", Typ.Pracovní));
            kontakty.Add(new Kontakt("Iva", "Mrkalová", "234567890", Typ.Soukromý));
            kontakty.Add(new Kontakt("Karel", "Hlaváček", "987654321", Typ.Soukromý));            
        }

        private static void Výpis<T>(IEnumerable<T> dotaz)
        {
            foreach (var kontakt in dotaz)
            {
                Console.WriteLine(kontakt);
            }
            Console.WriteLine("---");
        }
        static void Main(string[] args)
        {
            Příprava();
            Výpis(kontakty);
            var dotaz = from Kontakt kontakt in kontakty
                        where kontakt.Typ == Typ.Soukromý
                        select kontakt;
            Výpis(dotaz);
            
            var dotaz1 = kontakty.Where((kontakt) => kontakt.Typ == Typ.Pracovní);
            Výpis(dotaz1);
            var dotaz2 = from kontakt in kontakty
                         orderby kontakt.Příjmení
                         select kontakt.Příjmení + " " + kontakt.Jméno;
            Výpis(dotaz2);
            IEnumerable<string> dotaz3 = kontakty
                .OrderBy(kontakt => kontakt.Příjmení)
                .Select(x => x.Příjmení + ", " + x.Jméno);
            Výpis(dotaz3);
            var dotaz4 = from kontakt in kontakty
                         //where kontakt.Typ == Typ.Soukromý
                         orderby kontakt.Příjmení
                         group kontakt by kontakt.Typ;
            //Výpis(dotaz4); Nedá správný výsledek
            foreach(var skupina in dotaz4)
            {
                Console.WriteLine("--" + skupina.Key + "--");
                //foreach(var kontakt in skupina)
                //{
                //    Console.WriteLine(kontakt);
                //}
                Výpis(skupina);
            }
        }

        
    }
}